// ---------- Attention: Generated code, please do not modify! -----------  

/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.myfaces.tobago.component;

import javax.faces.context.FacesContext;
import org.apache.myfaces.tobago.context.Markup;
import org.apache.myfaces.tobago.internal.component.AbstractUITreeNode;
import org.apache.commons.lang.ArrayUtils;
import org.apache.commons.lang.StringUtils;
import org.apache.myfaces.tobago.component.MethodBindingToMethodExpression;
import org.apache.myfaces.tobago.component.MethodExpressionToMethodBinding;
import org.apache.myfaces.tobago.internal.util.Deprecation;
import org.apache.myfaces.tobago.renderkit.MarginValues;
import org.apache.myfaces.tobago.renderkit.SpacingValues;
import org.apache.myfaces.tobago.renderkit.LayoutComponentRenderer;
import javax.el.ELException;
import javax.faces.FacesException;
import java.util.ArrayList;
import java.util.List;
import javax.el.MethodExpression;
import javax.el.ValueExpression;

/** 
 Creates a tree node. This component represents a single node inside a tree structure.
  * UIComponent class, generated from template {@code component1.2.stg} with class
  * {@link org.apache.myfaces.tobago.internal.taglib.component.TreeNodeTagDeclaration}.
 */
public class UITreeNode
    extends AbstractUITreeNode implements SupportsMarkup {

  public static final String COMPONENT_TYPE = "org.apache.myfaces.tobago.TreeNode";

  private java.lang.Boolean selected;
  private java.lang.Boolean marked;
  private org.apache.myfaces.tobago.context.Markup markup;
  private org.apache.myfaces.tobago.context.Markup currentMarkup;
  private java.lang.Boolean expanded;
  private java.lang.Boolean disabled;
  private java.lang.String tip;


  /**
  Flag indicating if the node is selected (only possible, when the tree component allows it).
  <br />Default: <code>false</code>
  @deprecated*/
  @Deprecated
  public boolean isSelected() {
    if (selected != null) {
      return selected;
    }
    ValueExpression ve = getValueExpression("selected");
    if (ve != null) {
      try {
        Boolean bool = (Boolean) ve.getValue(getFacesContext().getELContext());
        if (bool != null) {
          return bool;
        }
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return false;
  }

  @Deprecated
  public void setSelected(boolean selected) {
      Deprecation.LOG.error("The attribute 'selected' of 'UITreeNode' is deprecated. "
          + "Please refer the documentation for further information.");
    this.selected = selected;
  }

  /**
  Flag indicating if the node is marked, and should be displayed in a special way.
  <br />Default: <code>false</code>
  @deprecated*/
  @Deprecated
  public boolean isMarked() {
    if (marked != null) {
      return marked;
    }
    ValueExpression ve = getValueExpression("marked");
    if (ve != null) {
      try {
        Boolean bool = (Boolean) ve.getValue(getFacesContext().getELContext());
        if (bool != null) {
          return bool;
        }
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return false;
  }

  @Deprecated
  public void setMarked(boolean marked) {
      Deprecation.LOG.error("The attribute 'marked' of 'UITreeNode' is deprecated. "
          + "Please refer the documentation for further information.");
    this.marked = marked;
  }

  public org.apache.myfaces.tobago.context.Markup getMarkup() {
    if (markup != null) {
      return markup;
    }
    ValueExpression ve = getValueExpression("markup");
    if (ve != null) {
      try {
        Object object = ve.getValue(getFacesContext().getELContext());
        return Markup.valueOf(object);
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return null;
  }

  public void setMarkup(org.apache.myfaces.tobago.context.Markup markup) {
    this.markup = markup;
  }

  public org.apache.myfaces.tobago.context.Markup getCurrentMarkup() {
    if (currentMarkup != null) {
      return currentMarkup;
    }
    return null;
  }

  public void setCurrentMarkup(org.apache.myfaces.tobago.context.Markup currentMarkup) {
    this.currentMarkup = currentMarkup;
  }

  /**
  Flag indicating if the subnodes are to be displayed.
  <br />Default: <code>false</code>
  @deprecated*/
  @Deprecated
  public boolean isExpanded() {
    if (expanded != null) {
      return expanded;
    }
    ValueExpression ve = getValueExpression("expanded");
    if (ve != null) {
      try {
        Boolean bool = (Boolean) ve.getValue(getFacesContext().getELContext());
        if (bool != null) {
          return bool;
        }
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return false;
  }

  @Deprecated
  public void setExpanded(boolean expanded) {
      Deprecation.LOG.error("The attribute 'expanded' of 'UITreeNode' is deprecated. "
          + "Please refer the documentation for further information.");
    this.expanded = expanded;
  }

  /**
  Flag indicating that this element is disabled.
  <br />Default: <code>false</code>
  */
  public boolean isDisabled() {
    if (disabled != null) {
      return disabled;
    }
    ValueExpression ve = getValueExpression("disabled");
    if (ve != null) {
      try {
        Boolean bool = (Boolean) ve.getValue(getFacesContext().getELContext());
        if (bool != null) {
          return bool;
        }
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return false;
  }

  public void setDisabled(boolean disabled) {
    this.disabled = disabled;
  }

  /**
  Text value to display as tooltip.

  */
  public java.lang.String getTip() {
    if (tip != null) {
      return tip;
    }
    ValueExpression ve = getValueExpression("tip");
    if (ve != null) {
      try {
        return (java.lang.String) ve.getValue(getFacesContext().getELContext());
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return null;
  }

  public void setTip(java.lang.String tip) {
    this.tip = tip;
  }

  public void restoreState(FacesContext context, Object componentState) {
    Object[] values = (Object[]) componentState;
    super.restoreState(context, values[0]);
    selected = (java.lang.Boolean) values[1];
    marked = (java.lang.Boolean) values[2];
    markup = (org.apache.myfaces.tobago.context.Markup) values[3];
    expanded = (java.lang.Boolean) values[4];
    disabled = (java.lang.Boolean) values[5];
    tip = (java.lang.String) values[6];
  }

  public Object saveState(FacesContext context) {
    Object[] values = new Object[7];
    values[0] = super.saveState(context);
    values[1] = selected;
    values[2] = marked;
    values[3] = markup;
    values[4] = expanded;
    values[5] = disabled;
    values[6] = tip;
    currentMarkup = null;
    return values;
  }


}