// ---------- Attention: Generated code, please do not modify! -----------  

/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.myfaces.tobago.component;

import javax.faces.context.FacesContext;
import org.apache.myfaces.tobago.context.Markup;
import org.apache.myfaces.tobago.internal.component.AbstractUITreeSelect;
import org.apache.commons.lang.ArrayUtils;
import org.apache.commons.lang.StringUtils;
import org.apache.myfaces.tobago.component.MethodBindingToMethodExpression;
import org.apache.myfaces.tobago.component.MethodExpressionToMethodBinding;
import org.apache.myfaces.tobago.internal.util.Deprecation;
import org.apache.myfaces.tobago.renderkit.MarginValues;
import org.apache.myfaces.tobago.renderkit.SpacingValues;
import org.apache.myfaces.tobago.renderkit.LayoutComponentRenderer;
import javax.el.ELException;
import javax.faces.FacesException;
import java.util.ArrayList;
import java.util.List;
import javax.el.MethodExpression;
import javax.el.ValueExpression;

/** 
 Makes a tree node selectable.
  * UIComponent class, generated from template {@code component1.2.stg} with class
  * {@link org.apache.myfaces.tobago.internal.taglib.component.TreeSelectTagDeclaration}.
 */
public class UITreeSelect
    extends AbstractUITreeSelect implements SupportsMarkup {

  public static final String COMPONENT_TYPE = "org.apache.myfaces.tobago.TreeSelect";

  private org.apache.myfaces.tobago.context.Markup markup;
  private java.lang.String label;
  private java.lang.String tip;
  private org.apache.myfaces.tobago.context.Markup currentMarkup;
  private java.lang.Boolean required;
  private java.lang.Boolean showCheckbox;
  private java.lang.Boolean disabled;


  public org.apache.myfaces.tobago.context.Markup getMarkup() {
    if (markup != null) {
      return markup;
    }
    ValueExpression ve = getValueExpression("markup");
    if (ve != null) {
      try {
        Object object = ve.getValue(getFacesContext().getELContext());
        return Markup.valueOf(object);
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return null;
  }

  public void setMarkup(org.apache.myfaces.tobago.context.Markup markup) {
    this.markup = markup;
  }

  /**
  Text value to display as label.
   If text contains an underscore the next character is used as accesskey.

  */
  public java.lang.String getLabel() {
    if (label != null) {
      return label;
    }
    ValueExpression ve = getValueExpression("label");
    if (ve != null) {
      try {
        return (java.lang.String) ve.getValue(getFacesContext().getELContext());
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return null;
  }

  public void setLabel(java.lang.String label) {
    this.label = label;
  }

  /**
  Text value to display as tooltip.

  */
  public java.lang.String getTip() {
    if (tip != null) {
      return tip;
    }
    ValueExpression ve = getValueExpression("tip");
    if (ve != null) {
      try {
        return (java.lang.String) ve.getValue(getFacesContext().getELContext());
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return null;
  }

  public void setTip(java.lang.String tip) {
    this.tip = tip;
  }

  public org.apache.myfaces.tobago.context.Markup getCurrentMarkup() {
    if (currentMarkup != null) {
      return currentMarkup;
    }
    return null;
  }

  public void setCurrentMarkup(org.apache.myfaces.tobago.context.Markup currentMarkup) {
    this.currentMarkup = currentMarkup;
  }

  /**
  Flag indicating that a value is required.
   If the value is an empty string a
   ValidationError occurs and a Error Message is rendered.
  <br />Default: <code>false</code>
  */
  public boolean isRequired() {
    if (required != null) {
      return required;
    }
    ValueExpression ve = getValueExpression("required");
    if (ve != null) {
      try {
        Boolean bool = (Boolean) ve.getValue(getFacesContext().getELContext());
        if (bool != null) {
          return bool;
        }
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return false;
  }

  public void setRequired(boolean required) {
    this.required = required;
  }

  /**
  Show a checkbox to visualize the selection state.
  <br />Default: <code>false</code>
  */
  public boolean isShowCheckbox() {
    if (showCheckbox != null) {
      return showCheckbox;
    }
    ValueExpression ve = getValueExpression("showCheckbox");
    if (ve != null) {
      try {
        Boolean bool = (Boolean) ve.getValue(getFacesContext().getELContext());
        if (bool != null) {
          return bool;
        }
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return false;
  }

  public void setShowCheckbox(boolean showCheckbox) {
    this.showCheckbox = showCheckbox;
  }

  /**
  Flag indicating that this element is disabled.
  <br />Default: <code>false</code>
  */
  public boolean isDisabled() {
    if (disabled != null) {
      return disabled;
    }
    ValueExpression ve = getValueExpression("disabled");
    if (ve != null) {
      try {
        Boolean bool = (Boolean) ve.getValue(getFacesContext().getELContext());
        if (bool != null) {
          return bool;
        }
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return false;
  }

  public void setDisabled(boolean disabled) {
    this.disabled = disabled;
  }

  public void restoreState(FacesContext context, Object componentState) {
    Object[] values = (Object[]) componentState;
    super.restoreState(context, values[0]);
    markup = (org.apache.myfaces.tobago.context.Markup) values[1];
    label = (java.lang.String) values[2];
    tip = (java.lang.String) values[3];
    required = (java.lang.Boolean) values[4];
    showCheckbox = (java.lang.Boolean) values[5];
    disabled = (java.lang.Boolean) values[6];
  }

  public Object saveState(FacesContext context) {
    Object[] values = new Object[7];
    values[0] = super.saveState(context);
    values[1] = markup;
    values[2] = label;
    values[3] = tip;
    values[4] = required;
    values[5] = showCheckbox;
    values[6] = disabled;
    currentMarkup = null;
    return values;
  }


}